// ************************************************************* 
// Programmbeispiel: LED Punktmatrix                                 
// Datum: 21.9.2005: mpa										 
//  
                                   

#include<reg517a.h>
#include<stdio.h>
#include<lcd.h>



// Globale variablen (beginnen mit g...)
sbit gdin 	=  P1^5;		// AS1100 Daten-Eingang
sbit gload 	=  P1^6;   		// AS1100 Load-Eingang
sbit gclk 	=  P3^5;		// AS1100 Takt-Eingang

// LED-Matrix Grafik 
// 	LSB		1 1 1 1 1 1 1 1
//			1 0 0 0 0 0 0 1
//			1 0 0 0 0 0 0 1		 
//			1 0 0 0 0 0 0 1
//			1 0 0 0 0 0 0 1
//			1 0 0 0 0 0 0 1
// 	MSB		1 1 1 1 1 1 1 1
// HEX:	  7F 41 41 41 41 41 41 7F	
char ggrafik1[8]={0x7F,0x41,0x41,0x41,0x41,0x41,0x41,0x7F};

// LED-Matrix Grafik 
// 	LSB		0 0 0 0 0 0 0 0
//			0 1 1 1 1 1 1 0
//			0 1 0 0 0 0 1 0	 
//			0 1 0 0 0 0 1 0	 
//			0 1 0 0 0 0 1 0	 
//			0 1 1 1 1 1 1 0	 
// 	MSB		0 0 0 0 0 0 0 0
// HEX:	  00 3e 22 22 22 22 3e 00	
char ggrafik2[8]={0x00,0x3e,0x22,0x22,0x22,0x22,0x3e,0x00};

// LED-Matrix Grafik 
// 	LSB		0 0 0 0 0 0 0 0
//			0 0 0 0 0 0 0 0
//			0 0 1 1 1 1 0 0 
//			0 0 1 0 0 1 0 0
//			0 0 1 1 1 1 0 0
//			0 0 0 0 0 0 0 0	 
// 	MSB		0 0 0 0 0 0 0 0
// HEX:	  00 00 1c 14 14 1c 00 00	
char ggrafik3[8]={0x00,0x00,0x1c,0x14,0x14,0x1c,0x00,0x00};

// LED-Matrix Grafik 
// 	LSB		0 0 0 0 0 0 0 0
//			0 0 0 0 0 0 0 0
//			0 0 0 0 0 0 0 0 
//			0 0 0 1 1 0 0 0
//			0 0 0 0 0 0 0 0 
//			0 0 0 0 0 0 0 0	 
// 	MSB		0 0 0 0 0 0 0 0
// HEX:	  00 00 00 08 08 00 00 00	
char ggrafik4[8]={0x00,0x00,0x00,0x08,0x08,0x00,0x00,0x00};


// Deklaration der Funktionen
void AS1100send(char , char);			// AS1100 Daten senden
void AS1100init(void);					// AS1100 inistialisieren
void AS1100display(char *);				// AS1100 stellt Matrix dar


main()
{
gclk  = 0;						// Inititialisieren der globalen Variablen
gdin  = 0;						// Inititialisieren der globalen Variablen
gload = 0;						// Inititialisieren der globalen Variablen

AS1100init();					// AS1100 initialisieren


while(1)						// Endlosschleife
	{
	AS1100display(ggrafik4);	// Matrix darstellen 
	warte(400);					// Warten
	AS1100display(ggrafik3);
	warte(400);
	AS1100display(ggrafik2);
	warte(400);
	AS1100display(ggrafik1);
	warte(400);
	AS1100display(ggrafik2);
	warte(400);
	AS1100display(ggrafik3);
	warte(400);
	}
}


// Funktionen
// Daten an AS1100 senden 
void AS1100send(char addr, char daten) 
{
unsigned char mask;				// Maske zum extrahieren eines Bits
								// Muss unsigned sein, sonst wird kein logischer shift gemacht

mask = 0x80;					// Maske beginnt mit 10000000
while(mask) 					// Adressbyte schicken MSB zuerst
	{
	gdin = (addr & mask); 		// Bit extrahieren und Ausgang setzten
	gclk = 1;					// positive Taktflanke erzeugen
	gclk = 0;					// negative Taktflanke erzeugen				
	mask = mask >> 1;			// Maske: bit um 1 Stelle nach rechts schieben 
	}
mask = 0x80;					// Maske beginnt mit 10000000
while(mask) 					// Datenbyte schicken MSB zuerst
	{
	gdin = (daten & mask); 		// Bit extrahieren und Ausgang setzten
	gclk = 1;					// positive Taktflanke erzeugen
	gclk = 0;					// negative Taktflanke erzeugen					
	mask = mask >> 1;			// Maske: bit um 1 Stelle nach rechts schieben
	}
gload = 1;						// Ladeimpuse erzeugen
gload = 0;

}

// AS1100 Initialisieren
void AS1100init(void)
{
gload = 1;						// Ladeimpuse erzeugen um Schieberegister auf Anfang zu setzen
gload = 0;


AS1100send(0x0E,0x02);			// Reset senden
AS1100send(0x0E,0x00);			// Reset verlassen
AS1100send(0x0C,0x01);			// Shutdown mode verlassen
AS1100send(0x0B,0x07);			// Scan limit setzen
AS1100send(0x09,0x00);			// Keine BCD-Dekodiereung
AS1100send(0x0A,0x0F);			// Intensity max
AS1100send(0x0F,0x00);			// Display test OFF
}

// Grafikarray auf AS1100 ausgeben
void AS1100display(char *array)
{
char i;							// Laufvariable
for(i=0;i<8;i++)				// Spalten 0-7
	{
	AS1100send(i+1,array[i]);	// Ausgabe: Spalte 1-8 , array[0-7]
	}
}
